/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import java.io.*;

/**
  * This program will copy Web Server Access Log file
  * to a text file in the input directory
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */

public class CopyLog {
   String os;     // operating system
   String[] cmd;  // cmd will contain the name of operation, source file name, and destination file name

   /**
     * The constructor will initiate the variable
     *
     * @param       argv    contain the name of operation, source file name, and destination file name
     */

   public CopyLog( String argv[] ) {
      // the singleton object which will store name of operating system
      Config config = Config.Factory();
      // getting operating system
      os = config.getOs();
      cmd = argv;
   }

   /**
    * Method copyLogFile will
    *  a) get reference of an Runtime object and use its exec method to run a process
    *     to copy Web Server Access Log file to the destination file in the input directory,
    *     if the program runs on unix m/c
    *  b) read from source file and write to deatinatin file, if the program runs on non unix m/c
    *
    * @exception   FileNotFoundException      if file can not be located
    *
    * @exception   IOException                for io exceptions
    */

   public void copyLogFile() {
      try {
         if( os.equals( "unix" ) ) {
            Runtime r = Runtime.getRuntime();
            Process p = r.exec( cmd ); // run command
         } else {
            String str;
            BufferedReader reader = new BufferedReader(
                                      new FileReader( cmd[1] ) );
            PrintWriter pw = new PrintWriter (
                               new BufferedWriter (
                                 new FileWriter( cmd[2] ) ) );
            str = reader.readLine();
            while( str != null ) {
               pw.println( str );
               str = reader.readLine();
            }
            reader.close();
            pw.close();
         }
       } catch( FileNotFoundException fnf ) {
         System.out.println( "CopyLog: Cannot locate input file! " + fnf.getMessage() );
      } catch ( IOException e ) {
         System.err.println( "CopyLog: " + e.getMessage() );
      }
   }
} // CopyLog
