/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import java.util.*;

/**
  * The program will store
  *  a) time id of the access record
  *  b) user id of the access record
  *  c) protocol id of the access record
  *  d) path id of the access record
  *  e) session id of the access
  *  f) number of bytes accessed
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */

public class MyRecord {
   private String timeID;            // time id of the access record
   private int userID;               // user id of the access record
   private int protocolID;           // protocol id of the access record
   private int pathID;               // path id of the access record
   private int sessionID;            // session id of the access
   private int nbyte;                // number of bytes access

   /**
     * The constructor will find and store components of the access record
     */

   public MyRecord( String str ) {
      String uID;
      String protID;
      String paID;
      String sID;
      String nb;
      StringTokenizer tok;

      // tokenization
      tok = new StringTokenizer( str, " " );
      if( tok.hasMoreTokens() ) {
         // getting timeID
         timeID = tok.nextToken();
      }
      if( tok.hasMoreTokens() ) {
         // getting userID
         uID = tok.nextToken();
         userID = Integer.parseInt( uID );
      }
      if( tok.hasMoreTokens() ) {
          // getting protocolID
          protID = tok.nextToken();
          protocolID = Integer.parseInt( protID );
      }
      if( tok.hasMoreTokens() ) {
         // getting pathID
         paID = tok.nextToken();
         pathID = Integer.parseInt( paID );
      }
      if( tok.hasMoreTokens() ) {
         // getting sessionID
         sID = tok.nextToken();
         sessionID = Integer.parseInt( sID );
      }
      if( tok.hasMoreTokens() ) {
         // getting number of bytes accessed
         nb = tok.nextToken();
         nbyte = Integer.parseInt( nb );
      }
   }

   /**
     * The constructor store components of the access record
     */

   public MyRecord( String tID, int uID, int protID, int paID, int sID, int nb ) {
      timeID = tID;
      userID = uID;
      protocolID = protID;
      pathID = paID;
      sessionID = sID;
      nbyte = nb;
   }

   /**
     * Method compareTo compare two userID of the access record.
     * It returns
     *    1) -1 if userID of current record is smaller than the record in argument
     *    2) 0 if both userIDs are equals
     *    3) 1 if userID of current record is larger than the record in argument
     *
     * @param          mr         MyRecord object
     *
     * @return                     -1, 0, or 1 based on comparision
     */

   public int compareTo( MyRecord mr ) {
      if( this.userID > mr.userID ) {
        return 1;
      } else if( this.userID < mr.userID ) {
        return -1;
      } else if( this.userID == mr.userID ) {
        return 0;
      }
      return -1;
   }

   /**
     * The getter methods
     */

   public String getTimeID() {
      return timeID;
   }
   public int getUserID() {
      return userID;
   }
   public int getProtocolID() {
      return protocolID;
   }
   public int getPathID() {
      return pathID;
   }
   public int getSessionID() {
      return sessionID;
   }
   public int getNByte() {
      return nbyte;
   }
} // MyRecord
