/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;

/**
* This program will provide user interface for relevant user inputs
* to create data sets based on path. It extends UserInput class.
*
* @author   MOHAMMED LIAKAT ALI   Student
*                                 School of Computer Science
*                                 University of Windsor
*
* @supervisor Dr. CHRISTIE EZEIFE Associate Professor
*                                 School of Computer Science
*                                 University of Windsor
*/

public class PathBasedDSUserInput extends UserInput implements ActionListener {
   private JTextArea out;            // prompt

   private JLabel paLab;             // prompt
   private JLabel paIDLab;           // prompt
   private JTextField pa;            // path input field
   private JLabel slash;             // slash
   private JTextField f;             // file input field
   private JTextField t;             // file type input field
   private JLabel sp1;               // space
   private JLabel sp2;               // space

   /**
    * The constructor will initialized out,
    * create & add a Panel to the container for path information,
    * add 'OK' button to action listener,
    * and add the Panel containing 'OK' button to the container
    */
   public PathBasedDSUserInput( JTextArea o ) {
      super( "Path Based Dataset", 4 );
      out = o;

      // creating a Panel to get  user input for path infromation of data set
      JPanel pPanel = new JPanel();
      FlowLayout pfl = new FlowLayout();
      pfl.setAlignment( FlowLayout.LEFT );
      pPanel.setLayout( pfl );
      pPanel.setBackground( Color.CYAN );
      // setting prompt and input fields for path
      paLab = new JLabel( "Please enter the path / file . type as: "
                         + "/~cs141/labs/  index  .  html" );
      pPanel.add( paLab );
      String psp = "                                                                                      ";
      JLabel pssl = new JLabel( psp );
      pPanel.add( pssl );
      paIDLab = new JLabel( "PathFileType: " );
      pPanel.add( paIDLab );
      pa = new JTextField( 15 );
      pa.setText( "/~cs141/labs" );
      pPanel.add( pa );
      slash = new JLabel( " / " );
      pPanel.add( slash );
      f = new JTextField( 5 );
      f.setText( "index" );
      pPanel.add( f );
      sp1 = new JLabel( " . " );
      pPanel.add( sp1 );
      t = new JTextField( 5 );
      t.setText( "html" );
      pPanel.add( t );
      sp2 = new JLabel( "      " );
      pPanel.add( sp2 );
      c.add( pPanel );

      ok.addActionListener( this );
      dPanel.add( ok );
      c.add( dPanel );

      setSize( 650, 450 );
      setVisible( true );
   }

   /**
     * Method actionPerformed collects user inputs and
     * sets Coordinator object variables
     *
     * @param       et      et is an ActionEvent object
     */

   public void actionPerformed( ActionEvent e ) {
     // if selection to collect user inputs and
     // to set Selector variables when user press OK button
     if ( e.getSource() == ok ) {
        // from start date input field
        String sddStr = sdd.getText();
        // from start month input
        String smonStr = smon;
        // from start year input field
        String syyyyStr = syyyy.getText();
        // from start year input field
        String shhStr = shh.getText();
        // from start minute input field
        String smmStr = smm.getText();
        // from start second input field
        String sssStr = sss.getText();
        // from start offset sign input field
        String sosignStr = sosign.getText();;
        // from start offset input field
        String sosStr = sos.getText();
        // creating start time string
        String stemp = sddStr + "/" + smonStr + "/" + syyyyStr + ":"
             + shhStr + ":" + smmStr + ":" + sssStr + "/"
             + sosignStr + sosStr;
        // setting selector startTime
        selector.setStartTime( stemp );

        // from end date input field
        String eddStr = edd.getText();
        // from end month input
        String emonStr = emon;
        // from end year input field
        String eyyyyStr = eyyyy.getText();
        // from end hour input field
        String ehhStr = ehh.getText();
        // from end minute input field
        String emmStr = emm.getText();
        // from end second input field
        String essStr = ess.getText();
        // from end offset sign input field
        String eosignStr = eosign.getText();;
        // from end offset input field
        String eosStr = eos.getText();
        // creating end time string
        String etemp = eddStr + "/" + emonStr + "/" + eyyyyStr + ":"
             + ehhStr + ":" + emmStr + ":" + essStr + "/"
             + eosignStr + eosStr;
        // setting selector endTime
        selector.setEndTime( etemp );

         // from path input field
         String paStr = pa.getText();
         // from path input field
         String fStr = f.getText();
         // from path input field
         String tStr = t.getText();

         //creating argument array
         String[] s = new String[3];
         if( paStr == null || paStr.equals( "" ) ) {
            paStr = "/";
         }
         if( paStr != null && !paStr.equals( "" ) ) {
            int i = paStr.lastIndexOf( "/" );
            if( ( i != 0 ) && ( i == ( paStr.length() - 1 ) ) ) {
               paStr = paStr.substring( 0, i );
            }
         }
         if( fStr == null || fStr.equals( "" ) ) {
            fStr = "-";
         }
         if( tStr == null || tStr.equals( "" ) ) {
            tStr = "-";
         }
         s[0] = paStr;
         s[1] = fStr;
         s[2] = tStr;
         // setting selector protocol
         selector.setPath( s );
         //for display
         out.setText( "Please press \"Data Set\" button now" );
         this.dispose();
      }
   }
} // PathBasedDSUserInput
