/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;

/**
  * This program will provide user interface for relevant user inputs
  * to create data sets based on protocol. It extends UserInput class.
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */

public class ProtocolBasedDSUserInput extends UserInput implements ActionListener {
   private JTextArea out;            // prompt

   private JLabel protLab;           // prompt
   private JLabel protIDLab;         // prompt
   private JTextField p;             // http protocol input field
   private JTextField m;             // method input field
   private JTextField s;             // status input field
   private JLabel sp5;               // space
   private JLabel sp6;               // space
   private JLabel sp7;               // space

   /**
     * The constructor will initialized out,
     * create & add a Panel to the container for potocol information,
     * add 'OK' button to action listener,
     * and add the Panel containing 'OK' button to the container
     */

   public ProtocolBasedDSUserInput( JTextArea o ) {
      super( "Protocol Based Dataset", 4 );
      out = o;

      // creating a Panel to get  user input for protocol infromation of data set
      JPanel pPanel = new JPanel();
      FlowLayout pfl = new FlowLayout();
      pfl.setAlignment( FlowLayout.LEFT );
      pPanel.setLayout( pfl );
      pPanel.setBackground( Color.CYAN );
      // setting prompt and input fields for protocol
      protLab = new JLabel( "Please enter the protocol as: "
                           + "HTTP/1.1	 GET  200" );
      pPanel.add( protLab );
      String psp = "                                                                                    ";
      JLabel pssl = new JLabel( psp );
      pPanel.add( pssl );
      protIDLab = new JLabel( "Protocol   Details:    HTTP/" );
      pPanel.add( protIDLab );
      p = new JTextField( 2 );
      p.setText( "1.1" );
      pPanel.add( p );
      sp5 = new JLabel( "   Method" );
      pPanel.add( sp5 );
      m = new JTextField( 3 );
      m.setText( "GET" );
      pPanel.add( m );
      sp6 = new JLabel( "   Status" );
      pPanel.add( sp6 );
      s = new JTextField( 2 );
      s.setText( "200" );
      pPanel.add( s );
      sp7 = new JLabel( "              " );
      pPanel.add( sp7 );
      c.add( pPanel );

      // adding action listener with ok button
      ok.addActionListener( this );
      dPanel.add( ok );
      c.add( dPanel );

      setSize( 650, 450 );
      setVisible( true );
   }

   /**
     * Method actionPerformed collects user inputs and
     * sets Selector object variables
     *
     * @param       et      et is an ActionEvent object
     */

   public void actionPerformed( ActionEvent e ) {
      // if selection to collect user inputs and
      // to set Selector variables when user press OK button
      if ( e.getSource() == ok ) {
         // from start date input field
         String sddStr = sdd.getText();
         // from start month input
         String smonStr = smon;
         // from start year input field
         String syyyyStr = syyyy.getText();
         // from start year input field
         String shhStr = shh.getText();
         // from start minute input field
         String smmStr = smm.getText();
         // from start second input field
         String sssStr = sss.getText();
         // from start offset sign input field
         String sosignStr = sosign.getText();;
         // from start offset input field
         String sosStr = sos.getText();
         // creating start time string
         String stemp = sddStr + "/" + smonStr + "/" + syyyyStr + ":"
             + shhStr + ":" + smmStr + ":" + sssStr + "/"
             + sosignStr + sosStr;
         // setting selector startTime
         selector.setStartTime( stemp );

         // from end date input field
         String eddStr = edd.getText();
         // from end month input
         String emonStr = emon;
         // from end year input field
         String eyyyyStr = eyyyy.getText();
         // from end hour input field
         String ehhStr = ehh.getText();
         // from end minute input field
         String emmStr = emm.getText();
         // from end second input field
         String essStr = ess.getText();
         // from end offset sign input field
         String eosignStr = eosign.getText();;
         // from end offset input field
         String eosStr = eos.getText();
         // creating end time string
         String etemp = eddStr + "/" + emonStr + "/" + eyyyyStr + ":"
             + ehhStr + ":" + emmStr + ":" + essStr + "/"
             + eosignStr + eosStr;
         // setting selector endTime
         selector.setEndTime( etemp );

         // from protocol input field
         String pStr = "HTTP/" + p.getText();
         // from protocol input field
         String mStr = m.getText();
         // from protocol input field
         String sStr = s.getText();

         //creating argument array
         String[] s = new String[3];
         s[0] = pStr;
         s[1] = mStr;
         s[2] = sStr;
         // setting selector protocol
         selector.setProtocol( s );
         //for display
         out.setText( "Please press \"Data Set\" button now" );
         this.dispose();
      }
   }
} // protocolBasedDSUserInput
