/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

/**
  * The program will create a single object.
  * The object will store value of:
  *   a)mode of operation
  *   b)user selected values to create data sets
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */

public class Selector {
   private static Selector selector;     // referenc to the singleton object
   private static String mode;           // will hold mode of operation :- auto & manual

   private static String startTime;      // will hold start time of data set
   private static String endTime;        // will hold start time of data set

   private static String user;           // will hold user for data set
   private static String[] prot;         // will hold protocol for data set
   private static String[] pa;           // will hold path for data set

   /**
     * The private constructor will not do any additinal activity
     */

   private Selector(){}

   /**
     * Method Factory will create a single object of the class
     */

   public static Selector Factory() {
      if( selector == null ) {
        selector = new Selector();
      }
      return selector;
   }

    // setter methods
    public void setMode( String ms ) {
      mode = ms;
   }

    public void setStartTime( String s ) {
       startTime = s;
    }
    public void setEndTime( String e ) {
       endTime = e;
    }
    public void setUser( String u ) {
       user = u;
    }
    public void setProtocol( String[] p ) {
       prot = p;
    }
    public void setPath( String[] p ) {
       pa = p;
    }

    // getter methods

    public String getMode() {
        return mode;
    }

    public String getStartTime() {
       return startTime;
    }
    public String getEndTime() {
       return endTime;
    }
    public String getUser() {
       return user;
    }
    public String[] getProtocol() {
        return prot;
    }
    public String[] getPath() {
        return pa;
    }
} // Selector
