/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import java.io.*;
import javax.swing.*;

/**
  * This class is also a top level program which will coordinate to
  *  a) build data warehouse in database or in text files
  *  b) delete data warehouse from database or in text files
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */

public class Table {
   private int count;              // 21 will build data warehouse in database
                                   // 22 will build data warehouse in text file
                                   // 23 will delete data warehouse from database
                                   // 24 will delete data warehouse from text file

   private JTextArea out;          // to display at top most GUI

   /**
     * The constructor will initiate variables
     */

   public Table( int c, JTextArea o ) {
      count = c;
      out = o;
   }

   /**
     * Method operation will cordinate building or deleting data warehouses
     */

   public void operation() {

      if( count == 21 ) {
         createDBTables();
      } else if( count == 22 ){
         createTFTables();
      } else if( count == 23 ) {
         deleteDBTables();
      } else if( count == 24 ){
         deleteTFTables();
      }

   }

   /**
     * Method createDBTables will create an object of
     * TableModel class and call createWarehouseTables method
     * to build data warehouse in database
     */

   public void  createDBTables() {
      int count = -1;

      System.out.println( "\nStart of database warehouse construction" );
      TableModel mod = new TableModel();
      count = mod.createWarehouseTables();
      mod.closeConnection();
      System.out.println( "End of database warehouse construction\n" );

      // for display
      if( count == 0 ) {
        out.setText( "Warehouse tables in Database  are created" );
      } else {
        out.setText( "Either warehouse tables in Database exist "
                     + "or unable to create" );
      }
   }

   /**
     * Method createTFTables will create an object of
     * TableControl class and call createWarehouseTables method
     * to build data warehouse in text files in the output directory
     */

   public void  createTFTables() {
      int count = -1;

      System.out.println( "\nStart of text files warehouse construction" );
      TableControl con = new TableControl();
      count = con.createWarehouseTables();
      System.out.println( "End of text files warehouse construction\n" );

      // for display
      if( count == 0 ) {
        out.setText( "Warehouse tables in Text File  are created" );
      } else {
        out.setText( "Either warehouse tables in Text file exist "
                     + "or unable to create" );
      }
   }

   /**
     * Method deleteDBTables will create an object of
     * TableModel class and call deleteWarehouseTables method
     * to delete data warehouse from database
     */

   public void  deleteDBTables() {
      int count = -1;

      System.out.println( "\nStart of database warehouse deletion" );
      TableModel mod = new TableModel();
      count = mod.deleteWarehouseTables();
      mod.closeConnection();
      System.out.println( "End of database warehouse deletion\n" );

      // for display
      if( count == 0 ) {
        out.setText( "Warehouse tables in Database  are deleted" );
      } else {
        out.setText( "Either warehouse tables in Database does not exist "
                     + "or unable to delete" );
      }
   }

   /**
     * Method deleteTFTables will create an object of
     * TableControl class and call deleteWarehouseTables method
     * to delete data warehouse in text files from the output directory
     */

   public void  deleteTFTables() {
      boolean flag;

      System.out.println( "\nStart of text files warehouse deletion" );
      TableControl con = new TableControl();
      flag = con.deleteWarehouseTables();
      System.out.println( "End of text files warehouse deletion\n" );

      if( flag ) {
        out.setText( "Warehouse tables in Text File  are deleted" );
      } else {
        out.setText( "Either warehouse tables in Text file does not exist "
                     + "or unable to delete" );
      }
   }

} // Table
