/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;

/**
  * This program will provide user interface for relevant user inputs
  * to create data sets based on time only. It extends UserInput class.
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */

public class TimeBasedDSUserInput extends UserInput implements ActionListener {
   private JTextArea out;           // prompt

   /**
     * The constructor will initialized out, add 'OK' button to action listener,
     * and add the Panel containing 'OK' button to the container
     */

   public TimeBasedDSUserInput( JTextArea o ) {
      super( "Time Based Dataset", 3 );
      out = o;

      // adding action listener with ok button
      ok.addActionListener( this );
      dPanel.add( ok );
      c.add( dPanel );

      setSize( 650, 450 );
      setVisible( true );
   }

   /**
     * Method actionPerformed collects user inputs and
     * sets Selector object variables
     *
     * @param       et      et is an ActionEvent object
     */

   public void actionPerformed( ActionEvent e ) {
      // if selection to collect user inputs and
      // to set Selector variables when user press OK button
      if ( e.getSource() == ok ) {
         // from start date input field
         String sddStr = sdd.getText();
         // from start month input
         String smonStr = smon;
         // from start year input field
         String syyyyStr = syyyy.getText();
         // from start year input field
         String shhStr = shh.getText();
         // from start minute input field
         String smmStr = smm.getText();
         // from start second input field
         String sssStr = sss.getText();
         // from start offset sign input field
         String sosignStr = sosign.getText();;
         // from start offset input field
         String sosStr = sos.getText();
         // creating start time string
         String stemp = sddStr + "/" + smonStr + "/" + syyyyStr + ":"
              + shhStr + ":" + smmStr + ":" + sssStr + "/"
              + sosignStr + sosStr;
         // setting selector startTime
         selector.setStartTime( stemp );

         // from end date input field
         String eddStr = edd.getText();
         // from end month input
         String emonStr = emon;
         // from end year input field
         String eyyyyStr = eyyyy.getText();
         // from end hour input field
         String ehhStr = ehh.getText();
         // from end minute input field
         String emmStr = emm.getText();
         // from end second input field
         String essStr = ess.getText();
         // from end offset sign input field
         String eosignStr = eosign.getText();;
         // from end offset input field
         String eosStr = eos.getText();
         // creating end time string
         String etemp = eddStr + "/" + emonStr + "/" + eyyyyStr + ":"
              + ehhStr + ":" + emmStr + ":" + essStr + "/"
              + eosignStr + eosStr;
         // setting selector endTime
         selector.setEndTime( etemp );
         // for display
         out.setText( "Please press \"Data Set\" button now" );
         this.dispose();
      }
   }
} // TimeBasedDSUserInput
