/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;

/**
  * This program will provide user interface for relevant user inputs
  * to create data sets based on user. It extends UserInput class.
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */

public class UserBasedDSUserInput extends UserInput implements ActionListener {
   private JTextArea out;            // prompt

   private JLabel uLab;              // prompt
   private JLabel uIDLab;            // prompt
   private JTextField h1;            // ip address (1st part) input field
   private JLabel d1;                // dot
   private JTextField h2;            // ip address (2nd part) input field
   private JLabel d2;                // dot
   private JTextField h3;            // ip address (3rd part) input field
   private JLabel d3;                // dot
   private JTextField h4;            // ip address (4th part) input field
   private JLabel sp2;               // space
   private JLabel sp3;               // space

   /**
     * The constructor will initialized out,
     * create & add a Panel to the container for user information,
     * add 'OK' button to action listener,
     * and add the Panel containing 'OK' button to the container
     */

   public UserBasedDSUserInput( JTextArea o ) {
      super( "User Based Dataset", 4 );
      out = o;

      // creating a Panel to get  user input for user infromation of data set
      JPanel uPanel = new JPanel();
      FlowLayout ufl = new FlowLayout();
      ufl.setAlignment( FlowLayout.LEFT );
      uPanel.setLayout( ufl );
      uPanel.setBackground( Color.CYAN );
      // setting prompt and input fields for user
      uLab = new JLabel( "Please enter the user ip address as: "
                        + "137.207.216.174" );
      uPanel.add( uLab );
      String usp = "                                                                                      ";
      JLabel ussl = new JLabel( usp );
      uPanel.add( ussl );
      uIDLab = new JLabel( "User   IP   Address:        " );
      uPanel.add( uIDLab );
      h1 = new JTextField( 2 );
      h1.setText( "137" );
      uPanel.add( h1 );
      d1 = new JLabel(" . ");
      uPanel.add( d1 );
      h2 = new JTextField( 2 );
      h2.setText( "207" );
      uPanel.add( h2 );
      d2 = new JLabel(" . ");
      uPanel.add( d2 );
      h3 = new JTextField( 2 );
      h3.setText( "216" );
      uPanel.add( h3 );
      d3 = new JLabel( " . " );
      uPanel.add( d3 );
      h4 = new JTextField( 2 );
      h4.setText( "174" );
      uPanel.add( h4 );
      sp3 = new JLabel( "                                 " );
      uPanel.add(sp3);
      c.add( uPanel );

      // adding action listener with ok button
      ok.addActionListener( this );
      dPanel.add( ok );
      c.add( dPanel );


      setSize( 650, 450 );
      setVisible( true );
   }

   /**
     * Method actionPerformed collects user inputs and
     * sets Selectorr object variables
     *
     * @param       et      et is an ActionEvent object
     */

   public void actionPerformed( ActionEvent e ) {
      // if selection to collect user inputs and
      // to set Selector variables when user press OK button
      if ( e.getSource() == ok ) {
         // from start date input field
         String sddStr = sdd.getText();
         // from start month input
         String smonStr = smon;
         // from start year input field
         String syyyyStr = syyyy.getText();
         // from start year input field
         String shhStr = shh.getText();
         // from start minute input field
         String smmStr = smm.getText();
         // from start second input field
         String sssStr = sss.getText();
         // from start offset sign input field
         String sosignStr = sosign.getText();;
         // from start offset input field
         String sosStr = sos.getText();
         // creating start time string
         String stemp = sddStr + "/" + smonStr + "/" + syyyyStr + ":"
             + shhStr + ":" + smmStr + ":" + sssStr + "/"
             + sosignStr + sosStr;
         // setting selector startTime
         selector.setStartTime( stemp );

         // from end date input field
         String eddStr = edd.getText();
         // from end month input
         String emonStr = emon;
         // from end year input field
         String eyyyyStr = eyyyy.getText();
         // from end hour input field
         String ehhStr = ehh.getText();
         // from end minute input field
         String emmStr = emm.getText();
         // from end second input field
         String essStr = ess.getText();
         // from end offset sign input field
         String eosignStr = eosign.getText();;
         // from end offset input field
         String eosStr = eos.getText();
         // creating end time string
         String etemp = eddStr + "/" + emonStr + "/" + eyyyyStr + ":"
             + ehhStr + ":" + emmStr + ":" + essStr + "/"
             + eosignStr + eosStr;
         // setting selector endTime
         selector.setEndTime( etemp );

         String h1Str = h1.getText();
         // from user input field
         String h2Str = h2.getText();
         // from user input field
         String h3Str = h3.getText();
         // from user input field
         String h4Str = h4.getText();
         //creating user string
         String temp = h1Str + "." + h2Str + "." + h3Str + "." + h4Str;
         // setting selector user
         selector.setUser( temp );
         // for display
         out.setText( "Please press \"Data Set\" button now" );
         this.dispose();
      }
   }
} // UserBasedDSUserInput
