/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;

/**
  * This class program will provide user interface
  * for user inputs to user id and password for database access
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */

public class DBLoginInfo extends JFrame implements ActionListener {
   private Container c;               // container

   private JTextArea out;             // prompt
   private int index;

   private JLabel userLab;            // prompt
   private JTextField user;           // user ID
   private String userStr;

   private JLabel pwdLab;             // prompt
   private JPasswordField pwd;        // password
   private String pwdStr;

   private JTextArea display;        // prompt
   private JButton ok;               // button

   /**
     * The constructor will initiate varibles
     */

   public DBLoginInfo( JTextArea o, int i ) {
      super( "User Input for Database login" );
      // getting a Container, and setting Layout manager and background color
      c = getContentPane();
      c.setLayout( new GridLayout( 3, 1 ) );
      c.setBackground( Color.CYAN );

      // initialization
      out = o;
      index = i;

      // setting prompt and input fields for userID
      JPanel uPanel = new JPanel();
      FlowLayout ufl = new FlowLayout();
      ufl.setAlignment( FlowLayout.LEFT );
      uPanel.setLayout( ufl );
      uPanel.setBackground( Color.CYAN );
      userLab = new JLabel( "Please enter your database userID" );
      uPanel.add( userLab );
      user = new JTextField( 20 );
      user.setText( "abcde" );
      uPanel.add( user );
      c.add( uPanel );

      // setting prompt and input fields for password
      JPanel pPanel = new JPanel();
      FlowLayout pfl = new FlowLayout();
      pfl.setAlignment( FlowLayout.LEFT );
      pPanel.setLayout( pfl );
      pPanel.setBackground( Color.CYAN );
      pwdLab = new JLabel( "Please enter your database password" );
      pPanel.add( pwdLab );
      pwd = new JPasswordField( "Hidden text", 15 );
      pwd.setText( "*********" );
      pPanel.add( pwd );
      c.add( pPanel );

      // prompt
      JPanel dPanel = new JPanel();
      dPanel.setLayout( new FlowLayout() );
      dPanel.setBackground( Color.CYAN );
      display = new JTextArea( 2, 35 );
      display.setText( "At the end of all data entry, press ok button"  );
      dPanel.add( display );
      // setting ok button
      ok = new JButton( "OK" );
      ok.addActionListener( this );
      dPanel.add( ok );
      c.add( dPanel );


      //setSize( 450, 350 );
      setSize( 450, 250 );
      setVisible( true );
   }

   /**
     * Method actionPerformed collects user inputs and
     * sets DBLogin object variables
     *
     * @param       et      et is an ActionEvent object
     */

   public void actionPerformed( ActionEvent e ) {

      // if selection to collect user inputs and
      // to set Coordinator variables
      if( e.getSource() == ok ) {
         // from input fields
         userStr = user.getText();
         pwdStr = new String ( pwd.getPassword() );
         // the singleton object which will store user id and password for database access
         DBLogin login = DBLogin.Factory();
         // setting uaer id
         login.setUserID( userStr );
         // setting password
         login.setPassword( pwdStr );

         // if-else selection for apropiate display
         if( index == 20 ) {
            out.setText( "Please press \"Data Set\" button now" );
         } else if( index == 21 ) {
            out.setText( "Please press \"Create Tables\" button now" );
         } else if( index == 23 ) {
            out.setText( "Please press \"Delete Tables\" button now" );
         } else if( index == 25 ) {
            out.setText( "Please press \"Store Data\" button now" );
         } else if( index == 27 ) {
            out.setText( "Please press \"Host\" button now" );
         }

         // to get user input without fail
         if( !userStr.equals( "abcde" ) && !pwdStr.equals( "*********" ) ) {
            this.dispose();
         }
      }
   }
} // DBLoginInfo
