/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

/**
  * This program will seperate path, file name, and file type from a string and
  * store the information to an array of String.
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */

public class FilePath {
   private String[] hold;        // will store path, file name, and file type

   /**
     * The constructor will call setFilePath method
     * to find path, file name, and file type information to initialize hold
     */

   public FilePath( String str ) {
      setFilePath( str);
   }

   /**
     * Method setFilePath will seperate file path , file, and file type
     * from the inputstring str
     *
     * @param       str      str is a string representing an access record
     */

   public void setFilePath( String str ) {
      int index = -1;
      int i = -1;

      String tmp = "";
      String temp = "";

      String path = "/";
      String file = "-";
      String type = "-";

      hold = new String[3];

      // if-else selection
      if( str != null && !str.equals( "/" ) ) {
         // str is not equals to '/'

         // getting path
         index = str.lastIndexOf( "/" );
         if ( index > 0 ) {
            path = str.substring( 0, index );
            index++;
            temp = str.substring( index, str.length() );
         } else {
            if( str.indexOf( "?" ) > 0 ) {
               path = "/";
               temp = str.substring( 1, str.length() );
            } else if( str.indexOf( "." ) > 0 ) {
               path = "/";
               temp = str.substring( 1, str.length() );
            } else if(  str.indexOf( "~" ) > 0 ) {
                path = str;
                temp = "";
            }
         }

         if( temp != null && !temp.equals( "" ) ) {
            // removing substring starting with ?
            i =  temp.indexOf( "?" );
            if( i > 0 ) {
               tmp = temp;
               temp = tmp.substring( 0, i );
            }
         }
         // getting file name
         index = -1;
         if( temp != null && !temp.equals( "" ) ) {
            index = temp.lastIndexOf( "." );
            //if file name and file type is seperated by '.'
            if( index != -1 ) {
               if( index == 0 ) {
                  file = "-";
               } else if( index > 0 ){
                  file = temp.substring( 0, index );
               }
               index++;
               type = temp.substring( index, temp.length() );
            } else {
               //if file name and file type is not seperated by '.'
               file = temp;
               type = "-";
            }
         }
      }
      // to deal with null and empty values of path, file, and type
      if( path == null || path.equals( "" ) ) {
         path = "/";
      }
      if( file == null || file.equals( "" ) ) {
         file = "-";
      }
      if( type == null || type.equals( "" ) ) {
         type = "-";
      }
      // assigning values to hold
      hold[0] = path;
      hold[1] = file;
      hold[2] = type;
   }

   /**
     * Method getPathFileType return path, file name, and file type
     *
     * @return                 path, file name, and file type as String array
     */

   public String[] getPathFileType() {
      return hold;
   }
} // FilePath
