/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import java.io.*;
import javax.swing.*;

/**
  * This class is also a top level program which will coordinate to
  *  a) get corresponding host name of IP address from DNS
  *  b) store the host name to UserDimTble of the warehouse
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */

public class HostNameCollector {
   private int count;              // 27 will store host name in data warehouse in database
                                   // 28 will store host name in data warehouse in text file

   private JTextArea out;          // to display at top most GUI

   /**
     * The constructor will initiate variables
     */

   public HostNameCollector( int c, JTextArea o ) {
      count = c;
      out = o;
   }

   /**
     * Method operation will cordinate getting and storing host name to data warehouses
     */

   public void operation() {

      if( count == 27 ) {
         updateDBUserDimTbl();
      } else if( count == 28 ){
         updateTFUserDimTbl();
      }
   }

   /**
     * Method updateDBUserDimTbl will create an object of
     * HostModel class and call updateDBUserDimTbl method
     * to get host names and store them to UserDimTbl of data warehouse in database
     */

   public void  updateDBUserDimTbl() {
      int count = -1;

      System.out.println( "\nStart of host name collection for database warehouse" );
      HostModel mod = new HostModel();
      count = mod.updateDBUserDimTbl();
      mod.closeConnection();
      System.out.println( "End of host name collection for database warehouse\n" );

      // for display
      if( count <= 0 ) {
        out.setText( "No new host name is stored to UserDimTbl of Database warehouse" );
      } else {
        out.setText( "Total " + count
                     + " new host names are stored into UserDimTbl of Database warehouse" );
      }
   }

   /**
     * Method updateTFUserDimTbl will create an object of
     * HostControl class and call updateTFUserDimTbl method
     * to get host names and store them to UserDimTbl of data warehouse in text files
     */

   public void  updateTFUserDimTbl() {
      int count = -1;

      System.out.println( "\nStart of host name collection for text files warehouse" );
      HostControl con = new HostControl();
      count = con.updateTFUserDimTbl();
      System.out.println( "End of host name collection for text files warehouse\n" );

      // for display
      if( count <= 0 ) {
        out.setText( "No new host name is stored to UserDimTbl of Text Files warehouse" );
      } else {
        out.setText( "Total " + count
                     + " new host names are stored into UserDimTbl of Text Files warehouse" );
      }
   }
} // HostNameCollector
