/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import java.util.*;

/**
  * This program will represent time stamp
  *    1) identify if two time stamp is in same session
  *    2) compare two time stamp
  *
* @author   MOHAMMED LIAKAT ALI   Student
*                                 School of Computer Science
*                                 University of Windsor
*
* @supervisor Dr. CHRISTIE EZEIFE Associate Professor
*                                 School of Computer Science
*                                 University of Windsor
*/

public class MyDate {
   // time stamp reprentation with offset
   private int year;
   private String month;
   private int date;
   private int hour;
   private int minute;
   private int second;
   private String offsetSign;
   private int offset;

   // time stamp representation with offset value adjusted
   private int adjustedYear;
   private String adjustedMonth;
   private int adjustedDate;
   private int adjustedHour;
   private int adjustedMinute;
   private int adjustedSecond;

   /**
     * The constructor will take string as input for the time stamp.
     * Initialize varibles for both
     *    1) time stamp reprentation with offset
     *    2) time stamp representation with offset value adjusted
     *
     * @param     t           time stamp as String
     */

   public MyDate( String t ) {
      StringTokenizer tok;
      String dateStr;
      String yearStr;
      String hourStr;
      String minuteStr;
      String secondStr;
      String offsetStr;

      // tokenizing the input String to store in variables for
      // time stamp representation with offset
      tok = new StringTokenizer( t, "/: " );

      if( tok.hasMoreTokens() ) {
         dateStr = tok.nextToken();
         date = Integer.parseInt( dateStr );
      }

      if( tok.hasMoreTokens() ) {
         month = tok.nextToken();
      }

      if( tok.hasMoreTokens() ) {
         yearStr = tok.nextToken();
         year = Integer.parseInt( yearStr );
      }

      if( tok.hasMoreTokens() ) {
         hourStr = tok.nextToken();
         hour = Integer.parseInt( hourStr );
      }

      if( tok.hasMoreTokens() ) {
         minuteStr = tok.nextToken();
         minute = Integer.parseInt( minuteStr );
      }

      if( tok.hasMoreTokens() ) {
         secondStr = tok.nextToken();
         second = Integer.parseInt( secondStr );
      }

      if( tok.hasMoreTokens() ) {
         String temp;

         offsetStr = tok.nextToken();
         if( offsetStr.length() > 1 ) {
            offsetSign = offsetStr.substring( 0, 1 );
            temp = offsetStr.substring( 1, offsetStr.length() );
            offset = Integer.parseInt( temp );
         }
      }
      // method call to initialize variables for
      // time stamp representation with offset value adjusted
      setAdjustedValues();
   }

   /**
     * The constructor will take string and integer as input for the time stamp.
     * Initialize varibles for both
     *    1) time stamp reprentation with offset
     *    2) time stamp representation with offset adjusted
     *
     * @param     date           int represents date
     *
     * @param     month          String represents month
     *
     * @param     year           int represents year
     *
     * @param     hour           int represents hour
     *
     * @param     minute         int represents minute
     *
     * @param     second         int represents second
     *
     * @param     offsetSign     String represents offset sign ( +/- )
     *
     * @param     offset         int represents offset
     */

   public MyDate( int date, String month, int year,
                  int hour, int minute, int second,
                  String offsetSign, int offset ) {
      // initializing variables for
      // time stamp representation with offset
      this.date = date;
      this.month = month;
      this.year = year;
      this.hour = hour;
      this.minute = minute;
      this.second = second;
      this.offsetSign = offsetSign;
      this.offset = offset;

      // method call to initialize variables for
      // time stamp representation with offset value adjusted
      setAdjustedValues();
   }

   /**
     * Method setAdjustedValues sets
     * time stamp representation with offset value adjusted
     */

   public void setAdjustedValues() {
      int carry = 0;
      boolean flag = false;
      boolean leapYear = isLeapYear( year );

      // if-else selection for intialization of variables for
      // time stamp representation with offset adjusted
      if( offsetSign != null && offsetSign.equalsIgnoreCase( "-" ) ){
         // when offset sign is '-'
         adjustedSecond = second;
         adjustedMinute = minute + ( offset % 100 );
         if( adjustedMinute >= 60 ) {
            adjustedMinute = adjustedMinute % 60;
            if( ( adjustedMinute / 60 ) >= 1 ) {
               carry = 1;
            } else {
               carry = 0;
            }
         }
         adjustedHour = hour + ( offset / 100 ) + carry;
         if( adjustedHour >= 24 ) {
            adjustedHour = adjustedHour % 24;
            if( ( adjustedHour / 24 ) >= 1 ) {
               carry = 1;
            } else {
               carry = 0;
            }
         }
         adjustedDate = date + carry;
         adjustedYear = year;
         if( month != null
                && month.equalsIgnoreCase( "Jan" ) && adjustedDate > 31 ) {
                  adjustedDate %= 31;
                  adjustedMonth = "Feb";
         } else if( month != null && month.equalsIgnoreCase( "Feb" )
                       && leapYear && adjustedDate > 29 ) {
                  adjustedDate %= 29;
                  adjustedMonth = "Mar";
         } else if( month != null && month.equalsIgnoreCase( "Feb" )
                       && !leapYear && adjustedDate > 28 ) {
                  adjustedDate %= 28;
                  adjustedMonth = "Mar";
         } else if( month != null && month.equalsIgnoreCase( "Mar" )
                       && adjustedDate > 31 ) {
                  adjustedDate %= 31;
                  adjustedMonth = "Apr";
         } else if( month != null && month.equalsIgnoreCase( "Apr" )
                       && adjustedDate > 30 ) {
                  adjustedDate %= 30;
                  adjustedMonth = "May";
         } else if( month != null && month.equalsIgnoreCase( "May" )
                       && adjustedDate > 31 ) {
                  adjustedDate %= 31;
                  adjustedMonth = "Jun";
         } else if( month != null && month.equalsIgnoreCase( "Jun" )
                       && adjustedDate > 30 ) {
                  adjustedDate %= 30;
                  adjustedMonth = "Jul";
         } else if( month != null && month.equalsIgnoreCase( "Jul" )
                       && adjustedDate > 31 ) {
                  adjustedDate %= 31;
                  adjustedMonth = "Aug";
         } else if( month != null && month.equalsIgnoreCase( "Aug" )
                       && adjustedDate > 31 ) {
                  adjustedDate %= 31;
                  adjustedMonth = "Sep";
         } else if( month != null && month.equalsIgnoreCase( "Sep" )
                       && adjustedDate > 30 ) {
                  adjustedDate %= 30;
                  adjustedMonth = "Oct";
         } else if( month != null && month.equalsIgnoreCase( "Oct" )
                       && adjustedDate > 31 ) {
                  adjustedDate %= 31;
                  adjustedMonth = "Nov";
         } else if( month != null && month.equalsIgnoreCase( "Nov" )
                       && adjustedDate > 30 ) {
                  adjustedDate %= 30;
                  adjustedMonth = "Dec";
         } else if( month != null && month.equalsIgnoreCase( "Dec" )
                       && adjustedDate > 31 ) {
                  adjustedDate %= 31;
                  adjustedMonth = "Jan";
                  adjustedYear++;
         }
      } else if( offsetSign != null && offsetSign.equalsIgnoreCase( "+" ) ) {
         // when offset sign is '+'
         adjustedSecond = second;
         adjustedMinute = minute - ( offset % 100 );
         carry = 0;
         if( adjustedMinute < 0 ) {
            adjustedMinute += 60;
            carry = 1;
         }
         adjustedHour = hour - ( ( offset / 100 ) + carry );
         carry = 0;
         if( adjustedHour < 0 ) {
            adjustedHour +=  24;
            carry = 1;
         }
         adjustedDate = date - carry;
         adjustedYear = year;
         if( adjustedDate <= 0 ) {
            if( month != null && month.equalsIgnoreCase( "Jan" ) ) {
               adjustedDate = 31;
               adjustedMonth = "Dec";
               adjustedYear--;
            } else if( month != null && month.equalsIgnoreCase( "Feb" ) ) {
               adjustedDate = 31;
               adjustedMonth = "Jan";
            } else if( month != null && month.equalsIgnoreCase( "Mar" ) ) {
               if( leapYear ) {
                  adjustedDate = 29;
               } else {
                  adjustedDate = 28;
               }
               adjustedMonth = "Feb";
            } else if( month != null && month.equalsIgnoreCase( "Apr" ) ) {
               adjustedDate = 31;
               adjustedMonth = "Mar";
            } else if( month != null && month.equalsIgnoreCase( "May" ) ) {
               adjustedDate = 30;
               adjustedMonth = "Apr";
            } else if( month != null && month.equalsIgnoreCase( "Jun" ) ) {
               adjustedDate = 31;
               adjustedMonth = "May";
            } else if( month != null && month.equalsIgnoreCase( "Jul" ) ) {
               adjustedDate = 30;
               adjustedMonth = "Jun";
            } else if( month != null && month.equalsIgnoreCase( "Aug" ) ) {
               adjustedDate = 31;
               adjustedMonth = "Jul";
            } else if( month != null && month.equalsIgnoreCase( "Sep" ) ) {
               adjustedDate = 31;
               adjustedMonth = "Aug";
            } else if( month != null && month.equalsIgnoreCase( "Oct" ) ) {
               adjustedDate = 30;
               adjustedMonth = "Sep";
            } else if( month != null && month.equalsIgnoreCase( "Nov" ) ) {
               adjustedDate = 31;
               adjustedMonth = "Oct";
            } else if( month != null && month.equalsIgnoreCase( "Dec" ) ) {
               adjustedDate = 30;
               adjustedMonth = "Nov";
            }
         }
      } else {
         // when there is no offset
         adjustedYear = year;
         adjustedMonth = month;
         adjustedDate = date;
         adjustedHour = hour;
         adjustedMinute = minute;
         adjustedSecond = second;
      }
   }

   // getter methods
   public int getYear() {
      return year;
   }

   public String getMonth() {
      return month;
   }

   public int getDay() {
      return date;
   }

   public int getHour() {
      return hour;
   }

   public int getMinute() {
      return minute;
   }

   public int getSecond() {
      return second;
   }

   public int getOffset() {
      return offset;
   }

   public String getOffsetSign() {
      return offsetSign;
   }

   public int getAdjustedYear() {
      return adjustedYear;
   }

   public String getAdjustedMonth() {
      return adjustedMonth;
   }

   public int getAdjustedDate() {
      return adjustedDate;
   }

   public int getAdjustedHour() {
      return adjustedHour;
   }

   public int getAdjustedMinute() {
      return adjustedMinute;
   }

   public int getAdjustedSecond() {
      return adjustedSecond;
   }

   /**
     * Method compareTo compare two time stamp representation in MyDate object.
     * It returns
     *    1) -1 if current time stamp is earlier than the argument's time stamp
     *    2) 0 if both time stamps are equals
     *    3) 1 if current time stamp is later than the argument's time stamp
     *
     * @param   lastAccessTime     MyDate object
     *
     * @return                     -1, 0, or 1 based on comparision
     */

   public int compareTo( MyDate lastAccessTime ) {
      int count = 0;

      if( this.adjustedYear > lastAccessTime.adjustedYear ) {
         count = 1;
         return count;
      } else if( this.adjustedYear < lastAccessTime.adjustedYear ) {
         count = -1;
         return count;
      }

      if( getMonthIndex( this.adjustedMonth ) > getMonthIndex(
                                             lastAccessTime.adjustedMonth ) ) {
         count = 1;
         return count;
      } else if( getMonthIndex( this.adjustedMonth ) < getMonthIndex(
                                             lastAccessTime.adjustedMonth ) ) {
         count = -1;
         return count;
      }

      if( this.adjustedDate > lastAccessTime.adjustedDate ) {
         count = 1;
         return count;
      } else if( this.adjustedDate < lastAccessTime.adjustedDate ) {
         count = -1;
         return count;
      }

      if( this.adjustedHour > lastAccessTime.adjustedHour ) {
         count = 1;
         return count;
      } else if( this.adjustedHour < lastAccessTime.adjustedHour ) {
         count = -1;
         return count;
      }

      if( this.adjustedMinute > lastAccessTime.adjustedMinute ) {
         count = 1;
         return count;
      } else if( this.adjustedMinute < lastAccessTime.adjustedMinute ) {
         count = -1;
         return count;
      }

      if( this.adjustedSecond > lastAccessTime.adjustedSecond ) {
         count = 1;
         return count;
      } else if( this.adjustedSecond < lastAccessTime.adjustedSecond ) {
         count = -1;
         return count;
      }
      return count;
   }

   /**
     * Method isLeapYear find if the year is leap year or not
     *
     * @param         year          int representation of year
     *
     * @return                      boolean
     */

   public boolean isLeapYear( int year ) {
      boolean flag = false;
      int count;
      int hun = year % 100;

      if( hun == 0 ) {
         count = year % 400;
      } else {
         count = year % 4;
      }

      if( count == 0 ) {
         flag = true;
      }
      return flag;
   }

   /**
     * Method getMonthIndex will find int representation of a month
     *
     * @param         year          int representation of year
     *
     * @return                      boolean
     */

   public int getMonthIndex( String m ) {
      String[] months = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                          "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
      int count = -1;

      for( int i = 0; i < months.length; i++ ) {
         if( m != null && m.equalsIgnoreCase( months [i] ) ) {
            count = i;
            break;
         }
      }
      return count;
   }

   /**
     * Method notInSameSession will determine
     * if MyDate objecta are in same session
     *
     * @param         d             Mydate object
     *
     * @return                      boolean
     */

   public boolean notInSameSession( MyDate d ) {
      boolean flag = false;

      // if adjustedYear fields are defferent, they are not in same session
      if( this.adjustedYear != d.adjustedYear ) {
         flag = true;
         return flag;
      }

      // if inde of adjustedMoth fields are defferent,
      // they are not in same session
      if( getMonthIndex( this.adjustedMonth ) != getMonthIndex(
                                                          d.adjustedMonth ) ) {
         flag = true;
         return flag;
      }

      // if adjustedDate fields are defferent, they are not in same session
      if( this.adjustedDate != d.adjustedDate ) {
         flag = true;
         return flag;
      }

      // if adjustedHour fields are defferent, they are not in same session
      if( this.adjustedHour != d.adjustedHour ) {
         flag = true;
         return flag;
      }

      // if adjustedMinut fields are deffer by 10 minutes,
      // they are not in same session
      int inactiveTime = this.adjustedMinute - d.adjustedMinute;
      if( inactiveTime > 10 || inactiveTime < -10 ) {
         flag = true;
         return flag;
      }
      // Otherwise they are in same session
      return flag;
   }

   /**
     * Method toString will return String representation of the time stamp
     *
     * @return                      String describing time
     */

   public String toString() {
      String temp = "";

      if( offset <= 999 ) {
         temp = date + "/" + month + "/" + year + ":"
              + hour + ":" + minute + ":" + second + " "
              +  offsetSign + "0" + offset;
      } else {
         temp = date + "/" + month + "/" + year + ":"
              + hour + ":" + minute + ":" + second + " "
              +  offsetSign + offset;
      }
      return temp;
   }
} // myDate
