/*
 * Version:
 *    $Research Project of Undergraduate Student Research Award$
 *    $Tools for Mining and Building Data Warehouses$
 *
 * Revisions:
 *   $Date : August 20, 2004$
 *
 *   $Date : January 10, 2005$
 */

import javax.swing.*;
import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;

/**
  * This class will provide user interface
  * for relevant user inputs to create data sets.
  * It is a base class.
  *
  * @author   MOHAMMED LIAKAT ALI   Student
  *                                 School of Computer Science
  *                                 University of Windsor
  *
  * @supervisor Dr. CHRISTIE EZEIFE Associate Professor
  *                                 School of Computer Science
  *                                 University of Windsor
  */


public class UserInput extends JFrame {
   protected Container c;                    // a container
   protected Selector selector;              // reference to a singleton object

   protected JTextField sdd;                 // for start day input
   protected String smon;                    // store start month input
   private JComboBox scb;                    // for selection of start month
   // months
   private String[] sname = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                              "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
   protected JTextField syyyy;                // for start year input
   protected JTextField shh;                  // for start hour input
   protected JTextField smm;                  // for start minute input
   protected JTextField sss;                  // for start second input
   protected JTextField sosign;               // for start offset sign input
   protected JTextField sos;                  // for start offset input

   protected JTextField edd;                  // for end day input
   protected String emon;                     // store  end month input
   private JComboBox ecb;                     // for selection of end month
   // months
   private String[] ename = { "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                              "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };
   protected JTextField eyyyy;                // for end year input
   protected JTextField ehh;                  // for end hour input
   protected JTextField emm;                  // for end minute input
   protected JTextField ess;                  // for end second input
   protected JTextField eosign;               // for end offset sign input
   protected JTextField eos;                  // for end offset input

   private JTextArea display;                 // prompt
   protected JPanel dPanel;                   // a Panel
   protected JButton ok;                      // button

   /**
     * The constructor will not do any additinal activity
     */

   public UserInput( int i ) { }

   /**
    * The constructor will create the GUI for user input
    */

   public UserInput( String str, int count ) {
      super( "User Input for " + str );

      // getting a Container, and setting Layout manager and background color
      c = getContentPane();
      c.setLayout( new GridLayout( count, 1 ) );
      c.setBackground( Color.CYAN );

      // the singleton object which will store user selection for data set
      selector = Selector.Factory();

      // creating a Panel to get  user input for start time of data set
      JPanel sPanel = new JPanel();
      FlowLayout sfl = new FlowLayout();
      sfl.setAlignment( FlowLayout.LEFT );
      sPanel.setLayout( sfl );
      sPanel.setBackground( Color.CYAN );

      // setting prompt and input fields for start timing
      JLabel sLab = new JLabel( "Please enter the starting time of data set as: "
                      + "dd/mmm/yyyy:hh:mm:ss -oooo" );
      sPanel.add( sLab );
      String ssp = "                                                             ";
      JLabel sssl = new JLabel( ssp );
      sPanel.add( sssl );
      JLabel sIDLab = new JLabel( "Start Time: " );
      sPanel.add( sIDLab );
      sdd = new JTextField( 2 );
      sdd.setText( "23" );
      sPanel.add( sdd );
      JLabel ssl1 = new JLabel( "/" );
      sPanel.add( ssl1 );
      smon = "Jan";
      scb = new JComboBox( sname );
      scb.addItemListener(
         new ItemListener() {
            public void itemStateChanged( ItemEvent e ) {
               if( e.getStateChange() == ItemEvent.SELECTED ) {
                  smon = sname[scb.getSelectedIndex()];
               }
            }
         }
      );
      sPanel.add( scb );
      JLabel ssl2 = new JLabel( "/" );
      sPanel.add( ssl2 );
      syyyy = new JTextField( 3 );
      syyyy.setText( "2004" );
      sPanel.add( syyyy );
      JLabel scol1 = new JLabel( ":" );
      sPanel.add( scol1 );
      shh = new JTextField( 2 );
      shh.setText( "14" );
      sPanel.add( shh );
      JLabel scol2 = new JLabel( ":" );
      sPanel.add( scol2 );
      smm = new JTextField( 2 );
      smm.setText( "20" );
      sPanel.add( smm );
      JLabel scol3 = new JLabel( ":" );
      sPanel.add( scol3 );
      sss = new JTextField( 2 );
      sss.setText( "21" );
      sPanel.add( sss );
      JLabel ssp1 = new JLabel("       ");
      sPanel.add( ssp1 );
      sosign = new JTextField( 1 );
      sosign.setText( "-" );
      sPanel.add( sosign );
      sos = new JTextField( 3 );
      sos.setText( "0500" );
      sPanel.add( sos );
      c.add( sPanel );

      // creating a Panel to get  user input for end time of data set
      JPanel ePanel = new JPanel();
      FlowLayout efl = new FlowLayout();
      efl.setAlignment( FlowLayout.LEFT );
      ePanel.setLayout( efl );
      ePanel.setBackground( Color.CYAN );
      // setting prompt and input fields for end timing
      JLabel etLab = new JLabel( "Please enter the end time of data set as: "
                      + "dd/mmm/yyyy:hh:mm:ss -oooo" );
      ePanel.add( etLab );
      String esp = "                                                             ";
      JLabel essl = new JLabel( esp );
      ePanel.add( essl );
      JLabel etIDLab = new JLabel( "End Time: " );
      ePanel.add( etIDLab );
      edd = new JTextField( 2 );
      edd.setText( "23" );
      ePanel.add( edd );
      JLabel esl1 = new JLabel( "/" );
      ePanel.add( esl1 );
      emon = "Jan";
      ecb = new JComboBox( sname );
      ecb.addItemListener(
         new ItemListener() {
            public void itemStateChanged( ItemEvent e ) {
               if( e.getStateChange() == ItemEvent.SELECTED ) {
                  emon = sname[ecb.getSelectedIndex()];
               }
            }
         }
      );
      ePanel.add( ecb );
      JLabel esl2 = new JLabel( "/" );
      ePanel.add( esl2 );
      eyyyy = new JTextField( 3 );
      eyyyy.setText( "2005" );
      ePanel.add( eyyyy );
      JLabel ecol1 = new JLabel( ":" );
      ePanel.add( ecol1 );
      ehh = new JTextField( 2 );
      ehh.setText( "14" );
      ePanel.add( ehh );
      JLabel ecol2 = new JLabel( ":" );
      ePanel.add( ecol2 );
      emm = new JTextField( 2 );
      emm.setText( "20" );
      ePanel.add( emm );
      JLabel ecol3 = new JLabel( ":" );
      ePanel.add( ecol3 );
      ess = new JTextField( 2 );
      ess.setText( "21" );
      ePanel.add( ess );
      JLabel esp1 = new JLabel("       ");
      ePanel.add( esp1 );
      eosign = new JTextField( 1 );
      eosign.setText( "-" );
      ePanel.add( eosign );
      eos = new JTextField( 3 );
      eos.setText( "0500" );
      ePanel.add( eos );
      c.add( ePanel );

      // creating a Panel for prompt
      dPanel = new JPanel();
      dPanel.setLayout( new FlowLayout() );
      dPanel.setBackground( Color.CYAN );
      display = new JTextArea( 2, 56 );
      display.setText( "At the end of all data entry, press ok button"  );
      dPanel.add( display );
      // setting ok button
      ok = new JButton( "OK" );
   }
} // UserInput
